/*******************************************************************************************************************
  @File Name: system.c
  @Summary: This is the mcc generated file using MPLAB(c) Code Configurator
  @Description: This file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 3.16
        Device            :  PIC16F1829
        Driver Version    :  1.02
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.38
        MPLAB             :  MPLAB X 3.40
*******************************************************************************************************************/

// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection->INTOSC oscillator: I/O function on CLKIN pin
#pragma config WDTE = OFF       // Watchdog Timer Enable->WDT disabled
#pragma config PWRTE = OFF      // Power-up Timer Enable->PWRT disabled
#pragma config MCLRE = ON       // MCLR Pin Function Select->MCLR/VPP pin function is MCLR
#pragma config CP = OFF         // Flash Program Memory Code Protection->Program memory code protection is disabled
#pragma config CPD = OFF        // Data Memory Code Protection->Data memory code protection is disabled
#pragma config BOREN = ON       // Brown-out Reset Enable->Brown-out Reset enabled
#pragma config CLKOUTEN = OFF   // CLKOUT function is disabled. I/O function on the CLKOUT pin
#pragma config IESO = OFF       // Internal/External Switchover->Internal/External Switchover mode is disabled
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable->Fail-Safe Clock Monitor is disabled

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection->Write protection off
#pragma config PLLEN = OFF      // PLL Enable->4x PLL disabled
#pragma config STVREN = ON      // Stack Overflow or Underflow will cause a Reset
#pragma config BORV = LO        // Brown-out Reset Voltage (Vbor), low trip point selected.
#pragma config LVP = OFF        // High-voltage on MCLR/VPP must be used for programming

/* PORT usage
 * I RA0 = ICSPDAT
 * I RA1 = ICSPCLK
 * I RA2 = INT0->FLOW_SENSOR
 * I RA3 = /MCLR
 * I RA4 = IOC->
 * I RA5 = IOC->
 * I RB4 =
 * I RB5 = IOC->
 * I RB6 =
 * I RB7 = IOC->
 * O RC0 = RS
 * O RC1 = R/W
 * O RC2 = E
 * O RC3 = BackLight Control?
 *IO RC4 = D4
 *IO RC5 = D5
 *IO RC6 = D6
 *IO RC7 = D7
*/

/*************** Includes *****************************************************************************************/
#include "system.h"

/*************** Global Data Declarations *************************************************************************/

/*******************************************************************************************************************
 * Function: void SYSTEM_Initialize(void);
 * Overview: Initializes the system and peripherials
 * PreCondition: None
*******************************************************************************************************************/
void SYSTEM_Initialize(void)
{
    OSCILLATOR_Initialize();
    PIN_MANAGER_Initialize();
    TMR1_Initialize();
}

/*******************************************************************************************************************
 * Function: void SYSTEM_Tasks(void);
 * Overview: perform system tasks as needed
 * PreCondition: None
*******************************************************************************************************************/
void SYSTEM_Tasks(void)
{
    
}

/*******************************************************************************************************************
 * Function: void OSCILLATOR_Initialize(void);
 * Overview: Initializes the oscillator
 * PreCondition: None
*******************************************************************************************************************/
void OSCILLATOR_Initialize(void)
{
    // SCS INTOSC; SPLLEN disabled; IRCF 16MHz_HF; 
    OSCCON = 0x7A;
    // LFIOFR disabled; HFIOFL not stable; OSTS intosc; PLLR disabled; HFIOFS not stable; 
    // HFIOFR disabled; MFIOFR disabled; T1OSCR disabled; 
    OSCSTAT = 0x00;
    // TUN 0; 
    OSCTUNE = 0x00;
}
/*************** End of File **************************************************************************************/