#ifndef SYSTEM_H
#define SYSTEM_H

/*************** Includes *****************************************************************************************/
#include <xc.h>
#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "pin_manager.h"
#include "interrupt_manager.h"
#include "tmr1.h"
#include "tmr0.h"
#include "app_IrrigationWatch.h"
#include "lcd.h"

/*************** Defines ******************************************************************************************/
#define _XTAL_FREQ  16000000

/*******************************************************************************************************************
 * Function: void SYSTEM_Initialize(void);
 * Overview: Initializes the system and peripherials
 * PreCondition: None
*******************************************************************************************************************/
void SYSTEM_Initialize(void);

/*******************************************************************************************************************
 * Function: void SYSTEM_Tasks(void);
 * Overview: perform system tasks as needed
 * PreCondition: None
*******************************************************************************************************************/
void SYSTEM_Tasks(void);

/*******************************************************************************************************************
 * Function: void OSCILLATOR_Initialize(void);
 * Overview: Initializes the oscillator
 * PreCondition: None
*******************************************************************************************************************/
void OSCILLATOR_Initialize(void);


#endif  /* SYSTEM_H */
/*************** End of File **************************************************************************************/